'
' ORANGE Operating System
' cdコマンド
' Copyright (C) 2020 PicoSoft
' cd <ディレクトリ名>
' カレントディレクトリーを変更します。
'
const MAX_PATH = 128
mstruct str {
	EMPTY_STRING ds ""
	SLASH ds "/"
	FL ds "f:"
	PARENT ds ".."
}
alias str.ROOT, str.SLASH
mstruct path {
	PATH rb MAX_PATH
}
mstruct env {
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct work {
	CURRENT_PATH rb MAX_PATH
	COMMAND rb MAX_PATH
	NAME rb MAX_PATH
	BUF rb 128
}
mstruct stat {
	MODE rb 1
	ATIME rb 20
	MTIME rb 20
	CTIME rb 20
	SIZE rb 15
	INT32SIZE rb 4
}

main()
end

def main() {
	getenv "DRIVE", env.DRIVE
	getenv "PATH_F", env.PATH_F
	getenv "PATH_S", env.PATH_S
	getenv "COMMAND", work.COMMAND // コマンドライン取得
	getArg(work.COMMAND, 1, work.NAME) // 1番目のパラメーター取得
	if (mstrcmp(work.NAME , str.EMPTY_STRING) = 0) {
		print "cd <directory name>"
		end
	}
	cd(work.NAME)
	setenv "PATH_F", env.PATH_F
	setenv "PATH_S", env.PATH_S
}

' カレントディレクトリーを変更します。
def cd(name) {
	var index
	if (mstrcmp(env.DRIVE, str.FL) == 0) {
		mstrcpy(work.CURRENT_PATH, env.PATH_F)
	} else {
		mstrcpy(work.CURRENT_PATH, env.PATH_S)
	}
	if (mstrcmp(name, str.ROOT) == 0) {
		mstrcpy(work.CURRENT_PATH, str.ROOT)
	}

	' 退避
	mstrcpy(work.BUF, work.CURRENT_PATH)

	if (mstrcmp(name, str.PARENT) == 0 &&
		mstrcmp(work.CURRENT_PATH, str.ROOT) == 0) {
		return
	}
	if (mstrcmp(name, str.PARENT) == 0) { // cd ..
		index = mstrrchr(work.CURRENT_PATH, '/') - work.CURRENT_PATH
		work.CURRENT_PATH[index] = 0
	} else if (name[0] == '/') {
		mstrcpy(work.CURRENT_PATH, name)
	} else {
		addPath(work.CURRENT_PATH, name)
	}
	if (work.CURRENT_PATH[0] == 0) {
		mstrcpy(work.CURRENT_PATH, str.ROOT)
	}
	stat.MODE[0] = 0
	getFullPath(path.PATH, work.CURRENT_PATH)
	fstat(path.PATH, stat.MODE)
	if (stat.MODE[0] != 1) { // 存在しないときは復元
		print "Path not found"
		print
		mstrcpy(work.CURRENT_PATH, work.BUF)
	}
	if (mstrcmp(env.DRIVE, str.FL) == 0) {
		mstrcpy(env.PATH_F, work.CURRENT_PATH)
	} else {
		mstrcpy(env.PATH_S, work.CURRENT_PATH)
	}
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to 255
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' パスを連結します。
def addPath(path, name) {
	if (mstrcmp(path, str.ROOT) != 0) {
		mstrcat(path, str.SLASH)
	}
	mstrcat(path, name)
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	getenv "DRIVE", env.DRIVE // カレントドライブ取得
	getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
	getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, str.ROOT) != 0) {
		mstrcat(fullPath, str.SLASH)
	}
	mstrcat(fullPath, p)
}
