'
' ORANGE Operating System
' dlコマンド
' Copyright (C) 2020 by PicoSoft
'
' dl <exeファイル名>
' シリアルコンソールからintファイルをダウンロードして、SDカード上にexeファイルを作成します。
'
const CR = 0x0d
const LF = 0x0a
const SPACE = 0x20
const SLASH = '/'
const ESC = 0x1b
const TRUE = 1
const MAX_PATH = 128

mstruct str {
	EMPTY_STRING ds ""
	SLASH ds "/"
	SD ds "s:"
	FL ds "f:"
}
alias str.ROOT, str.SLASH
mstruct path {
	PATH rb MAX_PATH
}
mstruct message {
	ERROR ds "[ERROR]"
	ESC ds "[ESC]"
	OK ds "[END]"
}
mstruct env {
	DRIVE rb 3 // "f":, "s:"
	PATH_F rb MAX_PATH // f:のカレントパス
	PATH_S rb MAX_PATH // s:のカレントパス
}
mstruct work {
	COMMAND rb MAX_PATH
	NAME rb 128
	BUF rb 33
	C rb 1
}

main()
end

' メイン処理
def main() {
	var isReceive
	var c
	var i
	var file
	getenv "COMMAND", work.COMMAND // コマンドライン取得
	getArg(work.COMMAND, 1, work.NAME) // 1番目のパラメーター取得
	if (mstrcmp(work.NAME , str.EMPTY_STRING) = 0) {
		print "dl <file name>"
		end
	}
	getFullPath(path.PATH, work.NAME)
	file = fopen(path.PATH, 1)
	if (file = -1) {
		print
		mprint message.ERROR
		print
		end
	}
	isReceive = 0
	print "[START]"
	while TRUE
		if (isReceive) {
			print ".";
		}
		i = 0
		while TRUE
			c = getHexChar()
			if (c = LF || c = '$') {
				break
			}
			if (c = 0) {
				close(file, message.ERROR)
			}
			if (c = ESC) {
				close(file, message.ESC)
			}
			work.BUF[i] = c
			i = i + 1
			if (33 < i) {
				close(file, message.ERROR)
			}
		wend
		isReceive = 1
		work.BUF[i] = 0
		if (c != '$' && mstrlen(work.BUF) = 0) { // 空行
			continue
		}
		write(file, work.BUF)
		if (c = '$') {
			close(file, message.OK)
		}
	wend
}

' ファイルをクローズして終了します。
def close(file, p) {
	fclose(file)
	print
	mprint p
	print
	end
}

' 完全パス名を作ります。
def getFullPath(fullPath, name) {
	var p
	var currentPath
	getenv "DRIVE", env.DRIVE // カレントドライブ取得
	getenv "PATH_F", env.PATH_F // カレントディレクトリ取得
	getenv "PATH_S", env.PATH_S // カレントディレクトリ取得
	p = name
	if (p[1] == ':') { // ドライブ指定あり
		fullPath[0] = p[0]
		fullPath[1] = p[1]
		fullPath[2] = 0
		p = p + 2
	} else {
		mstrcpy(fullPath, env.DRIVE) // カレントドライブ
	}
	if (p[0] == '/') { // ルートからの指定
		mstrcat(fullPath, p)
		return
	}
	if (fullPath[0] == 'f') {
		currentPath = env.PATH_F
	} else {
		currentPath = env.PATH_S
	}
	mstrcat(fullPath, currentPath)
	if (mstrcmp(currentPath, str.ROOT) != 0) {
		mstrcat(fullPath, str.SLASH)
	}
	mstrcat(fullPath, p)
}

' n番目の引数を取得します。
def getArg(p, n, arg) {
	var i
	var j
	var c
	for j = 0 to n
		for i = 0 to 255
			c = p[0]
			p = p + 1
			if (c = ' ' || c = 0) {
				break
			}
			arg[i] = c
		next
	next
	arg[i] = 0
}

' 受信したデータをバイナリーに変換してファイルに書き込ます。
def write(file, s) {
	var i
	var c
	i = 0
	while s[i] != 0
		c = hexToI(s[i])
		i = i + 1
		c = c * 16
		c = c + hexToI(s[i])
		i = i + 1
		work.C[0] = c
		fwrite(file, work.C, 1)
	wend
}

' 16進文字をバイナリーに変換します。
def hexToI(c) {
	if ('0' <= c && c <= '9') {
		return c - '0'
	}
	if ('A' <= c && c <= 'F') {
		return c - 'A' + 10
	}
}

' 1文字受信します。
def getHexChar() {
	var c
	while 1
		c = uartget()
		if (c = CR) {
			c = LF
		}
		if (c != -1) {
			return c
		}
	wend
}
