'
' ORANGE Operating System
' setupコマンド
' Copyright (C) 2020 PicoSoft
'
extern wifiBegin, 2
extern wifiStatus, 3
extern wifiLocalIP, 4
extern wifiDisconnect, 5
extern wifiReconnect, 6
const WL_IDLE_STATUS = 0
const WL_NO_SSID_AVAIL = 1
const WL_SCAN_COMPLETED = 2
const WL_CONNECTED = 3
const WL_CONNECT_FAILED = 4
const WL_CONNECTION_LOST = 5
const WL_DISCONNECTED = 6
const FALSE = 0
const TRUE = 1
const MAX_STRING = 128
mstruct str {
	CONFIG_FILE ds "f:/config.sys"
	SSID ds "SSID"
	PASSWORD ds "PASSWORD"
	KBSET ds "KBSET"
	TRUE ds "true"
}
mstruct work {
	C rb 1
	KEY rb MAX_STRING
	VALUE rb MAX_STRING
}
mstruct settings {
	SSID rb MAX_STRING
	PASSWORD rb MAX_STRING
	KBSET rb MAX_STRING
}
mstruct wifi {
	LOCAL_IP rb 16
}

main()
end

def main() {
	readConfig()
	if (settings.KBSET[0] == '1') {
		config 2, 1
	}
	wifiConnect()
}

' config.sysを読み込みます。
def readConfig() {
	var file
	var rc
	file = fopen(str.CONFIG_FILE, 0)
	if (file != -1) {
		while TRUE
			rc = readLine(file, work.KEY, work.VALUE)
			if (mstrcmp(work.KEY, str.SSID) == 0) {
				mstrcpy(settings.SSID, work.VALUE)
			}
			if (mstrcmp(work.KEY, str.PASSWORD) == 0) {
				mstrcpy(settings.PASSWORD, work.VALUE)
			}
			if (mstrcmp(work.KEY, str.KBSET) == 0) {
				mstrcpy(settings.KBSET, work.VALUE)
			}
			if (rc == -1) {
				break
			}
		wend
		fclose(file)
	}
}

' ファイルから1行読んで、keyとvalueに分解します。
def readLine(file, key, value) {
	var rc
	var i
	var p
	i = 0
	while i < MAX_STRING
		rc = fread(file, work.C, 1)
		if (rc != 1 || work.C[0] == '\n') {
			break
		}
		if (' ' < work.C[0]) {
			key[i] = work.C[0]
			i = i + 1
		}
	wend
	key[i] = 0
	p = mstrchr(key, '=')
	if (p != -1) {
		p[0] = 0
		mstrcpy(value, p + 1)
	}
	if (rc != 1) {
		return -1
	} else {
		return 0
	}
}

' WiFiに接続します。
def wifiConnect() {
	var status
	if (settings.SSID[0] == 0 || settings.PASSWORD[0] == 0) {
		return
	}
	status = wifiStatus()
	if (status == WL_CONNECTED) {
		return
	}
	wifiBegin(settings.SSID, settings.PASSWORD)
	while TRUE
		pause 250
		status = wifiStatus()
		if (status == WL_NO_SSID_AVAIL) {
			break
		}
		if (status == WL_CONNECTED) {
			print "Connected. ";
			wifiLocalIP(wifi.LOCAL_IP)
			mprint wifi.LOCAL_IP
			break
		}
		print ".";
	wend
}
